/*global define window*/
/*jslint browser:true*/
define([
     'testsuite/qunit',
     'testsuite/qunit-fixture!de_epages/product/ui/variationwizard-unity-test-prefilled-noproducts.html',
     'testsuite/qunit-fixture!de_epages/product/ui/variationwizard-unity-test-prefilled.html',
     'jquery',
     'de_epages/product/ui/variationwizard-unity-test-helper',
     'de_epages/product/ui/variationwizard-unity',
     'ep',

     'de_epages/product/ui/variationattribute-unity',
     'jquery/metaparse',
     '$ready!'
], function (QUnit, fixture1, fixture2, $, helper, de_epages, ep) {
        'use strict';

    // overwrite default timeout
    window.timeoutOverwrite = 60;

    var bus = $('div'),
        options = {
            input: '.ep-variationassistant-attributevalueinput',
            initialInput: '.ep-variationassistant-attributevalueinput-initial',
            list: '.ep-variationassistant-attributelist',
            bus: $('.ep-variationassistant-attributelist').closest('form')
        },
        values;

    QUnit.module("de_epages/product/ui/variationwizard-unity'");

    QUnit.asyncTest("test with existingProducts", function () {
        fixture2.init();

        var h = helper();

        window.setTimeout(function() {
            QUnit.ok(!$('#EnterNewAttributeButton').closest('.row').hasClass('HideElement'), 'New Attribute button is visible.');

            h.addAttribute()(function() {

                QUnit.ok($('#EnterNewAttributeButton').closest('.row').hasClass('HideElement'), 'New Attribute button is hidden after max attributes chosen.');
                h.testButtons({next: [1,1]});

                h.setAlias(2, 'test2')(function() {
                    h.testButtons({next: [0,1]});
                    QUnit.equal($('.ui-invalid').length, 1, 'one error found');

                    h.setValue(2, 0, 'value0')(function() {
                    h.addValue(2, 'value1')(function() {
                    h.setAlias(2, 'Attribute1')(function() {
                        h.testButtons({next: [1,1]});
                        QUnit.equal($('.ui-invalid').length, 0, 'no error found');

                        h.addValue(0, 'test1')(function() {
                            h.testButtons({next: [0,1]});
                            QUnit.equal($('.ui-invalid').length, 1, 'one error found');

                            h.deleteValue(0, 5)(function() {
                                h.nextStep()(function() {
                                    h.testButtons({back: [1,1], next: [0,1]});

                                    h.selectDefault(1)(function() {
                                        h.testButtons({back: [1,1], next: [1,1]});
                                        QUnit.equal($('.ui-invalid').length, 0, 'no error found');

                                        h.testButtons({back: [1,1], next: [1,1]});

                                        h.nextStep()(function() {
                                            h.testAliases(100);
                                            h.testButtons({back: [1,1], finish: [1,1]});

                                            fixture2.destroy();
                                            QUnit.start();
                                        });
                                    });
                                });
                            });
                        });
                    });
                    });
                    });
                });
            });
        }, 1000);
    });

    QUnit.asyncTest("test without existingProducts - attribute count", function () {
        fixture1.init();

        var h = helper();

        window.setTimeout(function() {
            QUnit.ok(!$('#EnterNewAttributeButton').closest('.row').hasClass('HideElement'), 'New Attribute button is visible.');
            h.addAttribute()(function() {
            h.addAttribute()(function() {
            h.addAttribute()(function() {

                QUnit.ok($('#EnterNewAttributeButton').closest('.row').hasClass('HideElement'), 'New Attribute button is hidden after max attributes added.');

                h.deleteAttribute(3)(function() {

                    h.testAttributeActive([1, 1, 0, 0]);
                    h.toggleAttribute(0)(function() {
                        h.testAttributeActive([1, 0, 0, 0]);
                        h.testButtons({next: [1,1]});

                        h.deleteAttribute(2)(function() {
                            h.testAttributeActive([1, 1, 0]);
                            QUnit.ok(!$('#EnterNewAttributeButton').closest('.row').hasClass('HideElement'), 'New Attribute button is visible.');

                            h.toggleAttribute(1)(function() {
                                QUnit.ok($('#EnterNewAttributeButton').closest('.row').hasClass('HideElement'), 'New Attribute button is hidden after max attributes selected.');

                                fixture2.destroy();
                                QUnit.start();
                            });
                        });
                    });

                });

            });
            });
            });
        }, 1000);
    });


});